SystemOrganization addCategory: #'Voyage-Mongo-Magritte'!

Trait named: #TVOMongoManyRelation
	uses: {}
	category: 'Voyage-Mongo-Magritte'!

!TVOMongoManyRelation classSide methodsFor: 'defaults' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
defaultKindCollection 
	^OrderedCollection! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/30/2012 17:54'!
convertNull
	^self 
		propertyAt: #convertNull 
		ifAbsent: [ nil ]! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/30/2012 18:14'!
convertNullTo: anObject
	self 
		propertyAt: #convertNull
		put: anObject! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/30/2012 18:14'!
convertNullToEmpty
	self convertNullTo: self kindCollection new! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
kindCollection 
	^self 
		propertyAt: #kindCollection 
		ifAbsent: [ self class defaultKindCollection ]! !

!TVOMongoManyRelation methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:19'!
kindCollection: aClass 
	self 
		propertyAt: #kindCollection 
		put: aClass! !

Trait named: #TVOMongoPostLoad
	uses: {}
	category: 'Voyage-Mongo-Magritte'!

!TVOMongoPostLoad methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/4/2012 20:51'!
postLoad
	^self 
		propertyAt: #postLoad 
		ifAbsent: [ nil ]! !

!TVOMongoPostLoad methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/4/2012 20:51'!
postLoad: aBlock
	^self 
		propertyAt: #postLoad 
		put: aBlock! !

MADescriptionBuilder subclass: #VOMongoDescriptionBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 3/3/2012 16:11'!
build: aClass
	| pragmas explicitDescriptions inferedDescriptions containerPragmas explicitContainer |
	
	containerPragmas := Pragma allNamed: #mongoContainer from: aClass theMetaClass to: Object.
	explicitContainer := containerPragmas isEmpty
		ifTrue: [ self buildInferedContainer: aClass ]
		ifFalse: [ self buildContainer: (containerPragmas first) in: aClass ].
	
	pragmas := Pragma allNamed: #mongoDescription: from: aClass theMetaClass to: Object.
	explicitDescriptions := pragmas collect: [ :each | self build: each in: aClass ].
	inferedDescriptions := (aClass allInstVarNames 
		copyWithoutAll: (explicitDescriptions collect: #attributeName))
		collect: [ :each | self buildInfered: each ]. 

	^explicitContainer 
		addAll: explicitDescriptions;
		addAll: inferedDescriptions;
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:51'!
build: aPragma in: aClass
	| description |
	description := (aPragma method valueWithReceiver: aClass arguments: #())
		attributeName: (aPragma argumentAt: 1);
		yourself.
	
	(description accessor isKindOf: MANullAccessor) 
		ifTrue: [ description accessor: (self buildDirectAccessorFor: (aPragma argumentAt: 1)) ].  
	
	^description! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:52'!
buildContainer: aPragma in: aClass
	| description |
	description := aPragma method valueWithReceiver: aClass arguments: #().
	
	description collectionName isEmptyOrNil 
		ifTrue: [ description collectionName: (self collectionNameFor: aClass) ].
	
	^description! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:49'!
buildDirectAccessorFor: aString
	^MAPluggableAccessor 
		read: [ :anObject | anObject instVarNamed: aString ]
		write: [ :anObject :value | anObject instVarNamed: aString put: value ]! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 12:49'!
buildInfered: aString
	^VOMongoAttributeDescription new
		attributeName: aString;
		accessor: (self buildDirectAccessorFor: aString);
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:53'!
buildInferedContainer: aClass
	^VOMongoContainer new 
		collectionName: (self collectionNameFor: aClass);
		yourself! !

!VOMongoDescriptionBuilder methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 15:52'!
collectionNameFor: aClass
	^(aClass name asString allButFirst: 2) asLegalSelector! !

MAVisitor subclass: #VOMongoVisitor
	instanceVariableNames: 'repository json object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoVisitor subclass: #VOMongoMaterializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoMaterializer methodsFor: 'private' stamp: 'EstebanLorenzano 3/3/2012 11:40'!
classFromJSON: aDictionary orDescription: aDescription
	^Smalltalk globals at: (aDictionary 
		at: self class fieldType
		ifAbsent: [ aDescription kind name ]) 
		asSymbol
 ! !

!VOMongoMaterializer methodsFor: 'materializing' stamp: 'EstebanLorenzano 10/29/2011 09:46'!
materialize: anObject fromJSON: aDictionary
	^self 
		materialize: anObject 
		fromJSON:  aDictionary 
		description: (self repository descriptionBuilder for: anObject class)
	! !

!VOMongoMaterializer methodsFor: 'materializing' stamp: 'EstebanLorenzano 3/4/2012 20:50'!
materialize: anObject fromJSON: aDictionary description: aDescription
	| oldObject oldJSON |
	
	oldObject := self object.
	oldJSON := self json.
	[  
	  self object: anObject.
	  self json: aDictionary.
	  self visit: aDescription.
	  aDescription postLoad
		ifNotNil: [ :block | block cull: self object ]. 
	 ^self object ]
	ensure: [ 
		self object: oldObject.
		self json: oldJSON ]! !

!VOMongoMaterializer methodsFor: 'private' stamp: 'EstebanLorenzano 3/3/2012 11:40'!
objectFromJSON: aDictionary orDescription: aDescription
	^(self classFromJSON: aDictionary orDescription: aDescription) basicNew
! !

!VOMongoMaterializer methodsFor: 'private' stamp: 'EstebanLorenzano 3/4/2012 20:25'!
retrieveObjectFrom: jsonDictionary description: aDescription
	| objectClass |
	objectClass := self classFromJSON: jsonDictionary orDescription: aDescription.
	^ aDescription isLazy
		 ifTrue: [
			VOLazyProxy
				repository: self repository
				objectClass: objectClass 
				id: (jsonDictionary at: self class fieldId) ]
		ifFalse: [ 
			self repository 
				selectOne: objectClass 
				where: (Dictionary with: '_id' -> (jsonDictionary at: self class fieldId)) ]! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:05'!
visitAttributeDescription: aDescription 
	self object 
		write: (self jsonAt: aDescription mongoName) 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/30/2012 18:19'!
visitToManyEmbededDescription: aDescription
	| plainElements elements |
	
	plainElements := self jsonAt: aDescription mongoName.
	plainElements 
		ifNotNil: [
			elements := (plainElements as: aDescription kindCollection) 
				collect: [ :each | 
					(self 
						materialize: (self 
							objectFromJSON: each 
							orDescription: aDescription)
						fromJSON: each) ] ]
		ifNil: [
			aDescription convertNull
				ifNotNil: [ :convertObject | elements := convertObject ] ].

	self object 
		write: elements 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/30/2012 18:15'!
visitToManyReferenceDescription: aDescription
	| plainElements elements |
	
	plainElements := self jsonAt: aDescription mongoName.
	plainElements
		ifNotNil: [ 
			elements := (plainElements as: aDescription kindCollection)
				collect: [ :each | self retrieveObjectFrom: each description: aDescription ] ]
		ifNil: [
			aDescription convertNull
				ifNotNil: [ :convertObject | elements := convertObject ] ].

	
	self object 
		write: elements 
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 2/11/2012 11:39'!
visitToOneEmbededDescription: aDescription
	self object 
		write: ((self jsonAt: aDescription mongoName)
			ifNotNil: [ :embededDictionary | 
				self 
					materialize: (self 
						objectFromJSON: embededDictionary 
						orDescription: aDescription)
					fromJSON: embededDictionary ])	
		using: aDescription! !

!VOMongoMaterializer methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/3/2012 12:47'!
visitToOneReferenceDescription: aDescription
	| element |
	
	element := (self jsonAt: aDescription mongoName) 
		ifNotNil: [ :reference | self retrieveObjectFrom: reference description: aDescription ].
	
	self object 
		write: element 
		using: aDescription! !

VOMongoVisitor subclass: #VOMongoSerializerPass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoSerializerPass methodsFor: 'private' stamp: 'EstebanLorenzano 2/11/2012 11:08'!
addSpecialAttributesFrom: anObject description: aDescription
	aDescription shouldRememberKind 
		ifTrue: [ self json at: self class fieldType put: anObject class name ].! !

!VOMongoSerializerPass methodsFor: 'private' stamp: 'EstebanLorenzano 10/29/2011 14:38'!
keyOf: anObject 
	^self repository 
		keyOf: anObject
		ifAbsent: [ VOMongoError signal: 'Invalid reference' ]! !

!VOMongoSerializerPass methodsFor: 'serializing' stamp: 'EstebanLorenzano 10/28/2011 22:00'!
serialize: anObject
	^self 
		serialize: anObject 
		description: (self repository descriptionBuilder for: anObject class)
	! !

!VOMongoSerializerPass methodsFor: 'serializing' stamp: 'EstebanLorenzano 3/5/2012 11:52'!
serialize: anObject description: aDescription
	^self 
		serialize: anObject 
		description: aDescription
		using: Dictionary new! !

!VOMongoSerializerPass methodsFor: 'serializing' stamp: 'EstebanLorenzano 3/5/2012 11:52'!
serialize: anObject description: aDescription using: aDictionary
	| oldObject oldJSON |
	
	oldObject := self object.
	oldJSON := self json.
	[  
	  self object: anObject.
	  self json: aDictionary.
	  self addSpecialAttributesFrom: anObject description: aDescription.
	  self visit: aDescription.
	  ^self json ]
	ensure: [ 
		self object: oldObject.
		self json: oldJSON ]! !

!VOMongoSerializerPass methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/5/2012 11:56'!
visitAttributeDescription: aDescription 
	self 
		jsonAt: aDescription mongoName 
		put: (self object readUsing: aDescription)! !

!VOMongoSerializerPass methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/30/2012 17:58'!
visitToManyEmbededDescription: aDescription
	| elements |
	
	elements := (self object readUsing: aDescription) 
		ifNotNil: [ :objects | 
			objects 
				collect: [ :each | self serialize: each ] 
				as: Array ].
	
	self 
		jsonAt: aDescription mongoName 
		put: elements! !

!VOMongoSerializerPass methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/5/2012 11:56'!
visitToOneEmbededDescription: aDescription
	| element |
	
	element := (self object readUsing: aDescription)
		ifNotNil: [ :embededObject | self serialize: embededObject ].

	self 
		jsonAt: aDescription mongoName 
		put: element! !

VOMongoSerializerPass subclass: #VOMongoSerializerPass1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoSerializerPass1 methodsFor: 'private' stamp: 'EstebanLorenzano 3/4/2012 21:34'!
ensurePersisted: anObject 
	anObject ifNil: [ ^self ].
	(self repository isNew: anObject)
		ifTrue: [ self repository save: anObject ]! !

!VOMongoSerializerPass1 methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/4/2012 21:48'!
visitToManyReferenceDescription: aDescription
	(self object readUsing: aDescription) 
		ifNotNil: [ :elements | 
			self object write: nil using: aDescription. 
			elements do: [ :each | self ensurePersisted: each ].
			self object write: elements using: aDescription.  ]
	
	! !

!VOMongoSerializerPass1 methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/4/2012 21:47'!
visitToOneReferenceDescription: aDescription
	(self object readUsing: aDescription) 
		ifNotNil: [ :element | 
			self object write: nil using: aDescription. 
			self ensurePersisted: element.
			self object write: element using: aDescription. ]! !

VOMongoSerializerPass subclass: #VOMongoSerializerPass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoSerializerPass2 methodsFor: 'private' stamp: 'EstebanLorenzano 3/4/2012 21:34'!
referenceToDictionary: anObject
	^(self repository descriptionBuilder for: anObject class) shouldRememberKind 
		ifTrue: [ 
			Dictionary 
				with: self class fieldId->(self keyOf: anObject)
				with: self class fieldType->anObject class name ]
		ifFalse: [ Dictionary with: self class fieldId->(self keyOf: anObject) ]! !

!VOMongoSerializerPass2 methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/4/2012 21:30'!
visitToManyReferenceDescription: aDescription
	(self object readUsing: aDescription) 
		ifNotNil: [ :elements |
			self 
				jsonAt: aDescription mongoName 
				put: (elements collect: [ :each | self referenceToDictionary: each ] as: Array) ]
		ifNil: [
			self jsonAt: aDescription mongoName put: nil ].
	
	! !

!VOMongoSerializerPass2 methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/4/2012 21:32'!
visitToOneReferenceDescription: aDescription
	(self object readUsing: aDescription) 
		ifNotNil: [ :element | .
			self  
				jsonAt: aDescription mongoName 
				put: (self referenceToDictionary: element) ]
		ifNil: [ 
			self jsonAt: aDescription mongoName put: nil ].
	
	! !

!VOMongoVisitor class methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/3/2012 11:53'!
fieldId 
	^'__id'! !

!VOMongoVisitor class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/11/2012 11:11'!
fieldType 
	^'__type'! !

!VOMongoVisitor class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 10/28/2011 22:14'!
repository: aRepository
	^self basicNew 
		initialize: aRepository;
		yourself! !

!VOMongoVisitor methodsFor: 'initialization' stamp: 'EstebanLorenzano 10/27/2011 16:16'!
initialize: aRepository
	repository := aRepository.
	self initialize! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
json
	^ json! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
json: anObject
	json := anObject! !

!VOMongoVisitor methodsFor: 'private' stamp: 'EstebanLorenzano 11/7/2011 14:52'!
jsonAt: aString 
	^self json 
		at: aString
		ifAbsent: [ nil ]! !

!VOMongoVisitor methodsFor: 'private' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
jsonAt: aString put: anObject
	self json at: aString put: anObject! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
object
	^ object! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 22:03'!
object: anObject
	object := anObject! !

!VOMongoVisitor methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 16:16'!
repository
	^repository! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
visitAttributeDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitContainer: aDescription
	aDescription do: [ :each |
		each acceptMagritte: self ] ! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitToManyEmbededDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/3/2012 16:00'!
visitToManyReferenceDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 11:36'!
visitToOneEmbededDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 3/3/2012 16:00'!
visitToOneReferenceDescription: aDescription
	self subclassResponsibility! !

!VOMongoVisitor methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
visitTransientDescription: aDescription! !

MAContainer subclass: #VOMongoContainer
	uses: TVOMongoPostLoad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoContainer class
	uses: TVOMongoPostLoad classTrait
	instanceVariableNames: ''!

!VOMongoContainer class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/29/2011 15:55'!
defaultCollectionName 
	^(self label allButFirst: 2) asLegalSelector! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/29/2011 15:42'!
collectionName 
	^self 
		propertyAt: #collectionName
		ifAbsent: [ self class defaultCollectionName ]! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/29/2011 15:43'!
collectionName: aString
	self 
		propertyAt: #collectionName
		put: aString! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/3/2012 10:43'!
rememberKind
	self 
		propertyAt: #rememberKind 
		put: true! !

!VOMongoContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/3/2012 10:43'!
shouldRememberKind
	^self 
		propertyAt: #rememberKind 
		ifAbsent: [ false ]! !

Object subclass: #VOMongoSerializer
	instanceVariableNames: 'repository passes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoSerializer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 3/30/2012 16:56'!
repository: aRepository
	^self basicNew 
		initialize: aRepository;
		yourself! !

!VOMongoSerializer methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/4/2012 21:38'!
initialize 
	super initialize.
	passes := Array 
		with: (VOMongoSerializerPass1 repository: self repository)
		with: (VOMongoSerializerPass2 repository: self repository)! !

!VOMongoSerializer methodsFor: 'initialization' stamp: 'EstebanLorenzano 3/30/2012 16:56'!
initialize: aRepository
	repository := aRepository.
	self initialize! !

!VOMongoSerializer methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/30/2012 16:55'!
repository
	^ repository! !

!VOMongoSerializer methodsFor: 'serializing' stamp: 'EstebanLorenzano 3/4/2012 21:35'!
serialize: anObject
	^self 
		serialize: anObject 
		description: (self repository descriptionBuilder for: anObject class)
		! !

!VOMongoSerializer methodsFor: 'serializing' stamp: 'EstebanLorenzano 3/5/2012 12:28'!
serialize: anObject description: aDescription
	| serialized |
	
	passes 
		do: [ :each | serialized := each serialize: anObject description: aDescription ].
	
	^serialized! !

MADescription subclass: #VOMongoDescription
	uses: TVOMongoPostLoad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoDescription class
	uses: TVOMongoPostLoad classTrait
	instanceVariableNames: ''!

VOMongoDescription subclass: #VOMongoAttributeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoAttributeDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 15:42'!
isAbstract 
	^false! !

!VOMongoAttributeDescription methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 10/27/2011 15:39'!
acceptMagritte: aVisitor
	aVisitor visitAttributeDescription: self.! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 14:53'!
attributeName
	^self 
		propertyAt: #attributeName
		ifAbsent: [ nil ]! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
attributeName: aString
	self 
		propertyAt: #attributeName
		put: aString! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
mongoName 
	^self 
		propertyAt: #mongoName 
		ifAbsent: [ self attributeName ]! !

!VOMongoDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
mongoName: aString 
	self 
		propertyAt: #mongoName 
		put: aString! !

!VOMongoDescription methodsFor: 'printing' stamp: 'EstebanLorenzano 3/3/2012 15:35'!
printOn: aStream
	aStream nextPutAll: (self attributeName ifNil: [ 'Undefined' ])! !

VOMongoDescription subclass: #VOMongoRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoRelationDescription subclass: #VOMongoEmbededDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoEmbededDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 15:41'!
isAbstract 
	^false! !

VOMongoEmbededDescription subclass: #VOMongoToManyEmbededDescription
	uses: TVOMongoManyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoToManyEmbededDescription class
	uses: TVOMongoManyRelation classTrait
	instanceVariableNames: ''!

!VOMongoToManyEmbededDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:00'!
acceptMagritte: aVisitor
	aVisitor visitToManyEmbededDescription: self.! !

VOMongoEmbededDescription subclass: #VOMongoToOneEmbededDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoToOneEmbededDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 11:36'!
acceptMagritte: aVisitor
	aVisitor visitToOneEmbededDescription: self.! !

VOMongoRelationDescription subclass: #VOMongoReferenceDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoReferenceDescription class methodsFor: 'defaults' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
defaultLazy 
	^false! !

!VOMongoReferenceDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 16:14'!
isAbstract 
	^false! !

!VOMongoReferenceDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
beEager 
	self 
		propertyAt: #lazy 
		put: false! !

!VOMongoReferenceDescription methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/28/2011 12:30'!
beLazy 
	self 
		propertyAt: #lazy 
		put: true! !

!VOMongoReferenceDescription methodsFor: 'testing' stamp: 'EstebanLorenzano 10/28/2011 12:31'!
isEager
	^self isLazy not! !

!VOMongoReferenceDescription methodsFor: 'testing' stamp: 'EstebanLorenzano 10/28/2011 12:30'!
isLazy 
	^self 
		propertyAt: #lazy 
		ifAbsent: [ self class defaultLazy ]! !

VOMongoReferenceDescription subclass: #VOMongoToManyReferenceDescription
	uses: TVOMongoManyRelation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

VOMongoToManyReferenceDescription class
	uses: TVOMongoManyRelation classTrait
	instanceVariableNames: ''!

!VOMongoToManyReferenceDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:15'!
acceptMagritte: aVisitor 
	aVisitor visitToManyReferenceDescription: self! !

VOMongoReferenceDescription subclass: #VOMongoToOneReferenceDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoToOneReferenceDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/28/2011 12:15'!
acceptMagritte: aVisitor 
	aVisitor visitToOneReferenceDescription: self! !

VOMongoDescription subclass: #VOMongoTransientDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Mongo-Magritte'!

!VOMongoTransientDescription class methodsFor: 'testing' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
isAbstract 
	^false! !

!VOMongoTransientDescription methodsFor: 'visiting' stamp: 'EstebanLorenzano 10/27/2011 16:15'!
acceptMagritte: aVisitor 
	aVisitor visitTransientDescription: self! !
